/* valaproperty.c generated by valac, the Vala compiler
 * generated from valaproperty.vala, do not modify */

/* valaproperty.vala
 *
 * Copyright (C) 2006-2012  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 *	Raffaele Sandrini <raffaele@sandrini.ch>
 */

#include "vala.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <valagee.h>
#include <glib-object.h>

#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _vala_source_file_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_file_unref (var), NULL)))

struct _ValaPropertyPrivate {
	ValaParameter* _this_parameter;
	gboolean _interface_only;
	gboolean _is_abstract;
	gboolean _is_virtual;
	gboolean _overrides;
	ValaMemberBinding _binding;
	gboolean _lock_used;
	ValaExpression* _initializer;
	ValaDataType* _data_type;
	ValaProperty* _base_property;
	ValaProperty* _base_interface_property;
	gboolean base_properties_valid;
	ValaPropertyAccessor* _get_accessor;
	ValaPropertyAccessor* _set_accessor;
	gchar* _nick;
	gchar* _blurb;
	gboolean* _notify;
	ValaField* _field;
	gboolean _field_checked;
};

static gint ValaProperty_private_offset;
static gpointer vala_property_parent_class = NULL;
static ValaLockableIface * vala_property_vala_lockable_parent_iface = NULL;

static gboolean* _bool_dup (gboolean* self);
static void vala_property_find_base_properties (ValaProperty* self);
static void vala_property_real_accept (ValaCodeNode* base,
                                ValaCodeVisitor* visitor);
static void vala_property_real_accept_children (ValaCodeNode* base,
                                         ValaCodeVisitor* visitor);
static void vala_property_real_replace_type (ValaCodeNode* base,
                                      ValaDataType* old_type,
                                      ValaDataType* new_type);
static void vala_property_real_replace_expression (ValaCodeNode* base,
                                            ValaExpression* old_node,
                                            ValaExpression* new_node);
static void vala_property_find_base_interface_property (ValaProperty* self,
                                                 ValaClass* cl);
static void vala_property_find_base_class_property (ValaProperty* self,
                                             ValaClass* cl);
static gboolean vala_property_real_check (ValaCodeNode* base,
                                   ValaCodeContext* context);
static void vala_property_finalize (ValaCodeNode * obj);

static inline gpointer
vala_property_get_instance_private (ValaProperty* self)
{
	return G_STRUCT_MEMBER_P (self, ValaProperty_private_offset);
}

ValaDataType*
vala_property_get_property_type (ValaProperty* self)
{
	ValaDataType* result;
	ValaDataType* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_data_type;
	result = _tmp0_;
	return result;
}

static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}

void
vala_property_set_property_type (ValaProperty* self,
                                 ValaDataType* value)
{
	ValaDataType* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_data_type);
	self->priv->_data_type = _tmp0_;
	if (value != NULL) {
		ValaDataType* _tmp1_;
		_tmp1_ = self->priv->_data_type;
		vala_code_node_set_parent_node ((ValaCodeNode*) _tmp1_, (ValaCodeNode*) self);
	}
}

ValaPropertyAccessor*
vala_property_get_get_accessor (ValaProperty* self)
{
	ValaPropertyAccessor* result;
	ValaPropertyAccessor* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_get_accessor;
	result = _tmp0_;
	return result;
}

void
vala_property_set_get_accessor (ValaProperty* self,
                                ValaPropertyAccessor* value)
{
	ValaPropertyAccessor* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_get_accessor);
	self->priv->_get_accessor = _tmp0_;
	if (value != NULL) {
		ValaScope* _tmp1_;
		ValaScope* _tmp2_;
		_tmp1_ = vala_symbol_get_scope ((ValaSymbol*) self);
		_tmp2_ = _tmp1_;
		vala_symbol_set_owner ((ValaSymbol*) value, _tmp2_);
	}
}

ValaPropertyAccessor*
vala_property_get_set_accessor (ValaProperty* self)
{
	ValaPropertyAccessor* result;
	ValaPropertyAccessor* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_set_accessor;
	result = _tmp0_;
	return result;
}

void
vala_property_set_set_accessor (ValaProperty* self,
                                ValaPropertyAccessor* value)
{
	ValaPropertyAccessor* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_set_accessor);
	self->priv->_set_accessor = _tmp0_;
	if (value != NULL) {
		ValaScope* _tmp1_;
		ValaScope* _tmp2_;
		_tmp1_ = vala_symbol_get_scope ((ValaSymbol*) self);
		_tmp2_ = _tmp1_;
		vala_symbol_set_owner ((ValaSymbol*) value, _tmp2_);
	}
}

ValaParameter*
vala_property_get_this_parameter (ValaProperty* self)
{
	ValaParameter* result;
	ValaParameter* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_this_parameter;
	result = _tmp0_;
	return result;
}

void
vala_property_set_this_parameter (ValaProperty* self,
                                  ValaParameter* value)
{
	ValaParameter* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_this_parameter);
	self->priv->_this_parameter = _tmp0_;
}

gboolean
vala_property_get_interface_only (ValaProperty* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_interface_only;
	return result;
}

void
vala_property_set_interface_only (ValaProperty* self,
                                  gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_interface_only = value;
}

gboolean
vala_property_get_is_abstract (ValaProperty* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_abstract;
	return result;
}

void
vala_property_set_is_abstract (ValaProperty* self,
                               gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_is_abstract = value;
}

gboolean
vala_property_get_is_virtual (ValaProperty* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_virtual;
	return result;
}

void
vala_property_set_is_virtual (ValaProperty* self,
                              gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_is_virtual = value;
}

gboolean
vala_property_get_overrides (ValaProperty* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_overrides;
	return result;
}

void
vala_property_set_overrides (ValaProperty* self,
                             gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_overrides = value;
}

ValaField*
vala_property_get_field (ValaProperty* self)
{
	ValaField* result;
	ValaField* _tmp50_;
	g_return_val_if_fail (self != NULL, NULL);
	if (!self->priv->_field_checked) {
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_;
		_tmp1_ = self->priv->_is_abstract;
		if (!_tmp1_) {
			ValaSourceFileType _tmp2_;
			ValaSourceFileType _tmp3_;
			_tmp2_ = vala_symbol_get_source_type ((ValaSymbol*) self);
			_tmp3_ = _tmp2_;
			_tmp0_ = _tmp3_ == VALA_SOURCE_FILE_TYPE_SOURCE;
		} else {
			_tmp0_ = FALSE;
		}
		if (_tmp0_) {
			gboolean has_get = FALSE;
			ValaPropertyAccessor* _tmp4_;
			ValaPropertyAccessor* _tmp5_;
			gboolean _tmp6_ = FALSE;
			gboolean get_has_body = FALSE;
			gboolean has_set = FALSE;
			ValaPropertyAccessor* _tmp11_;
			ValaPropertyAccessor* _tmp12_;
			gboolean _tmp13_ = FALSE;
			gboolean set_has_body = FALSE;
			gboolean _tmp18_ = FALSE;
			gboolean _tmp22_ = FALSE;
			gboolean _tmp26_ = FALSE;
			_tmp4_ = vala_property_get_get_accessor (self);
			_tmp5_ = _tmp4_;
			has_get = _tmp5_ != NULL;
			if (has_get) {
				ValaPropertyAccessor* _tmp7_;
				ValaPropertyAccessor* _tmp8_;
				ValaBlock* _tmp9_;
				ValaBlock* _tmp10_;
				_tmp7_ = vala_property_get_get_accessor (self);
				_tmp8_ = _tmp7_;
				_tmp9_ = vala_subroutine_get_body ((ValaSubroutine*) _tmp8_);
				_tmp10_ = _tmp9_;
				_tmp6_ = _tmp10_ != NULL;
			} else {
				_tmp6_ = FALSE;
			}
			get_has_body = _tmp6_;
			_tmp11_ = vala_property_get_set_accessor (self);
			_tmp12_ = _tmp11_;
			has_set = _tmp12_ != NULL;
			if (has_set) {
				ValaPropertyAccessor* _tmp14_;
				ValaPropertyAccessor* _tmp15_;
				ValaBlock* _tmp16_;
				ValaBlock* _tmp17_;
				_tmp14_ = vala_property_get_set_accessor (self);
				_tmp15_ = _tmp14_;
				_tmp16_ = vala_subroutine_get_body ((ValaSubroutine*) _tmp15_);
				_tmp17_ = _tmp16_;
				_tmp13_ = _tmp17_ != NULL;
			} else {
				_tmp13_ = FALSE;
			}
			set_has_body = _tmp13_;
			if (set_has_body) {
				gboolean _tmp19_ = FALSE;
				if (has_get) {
					_tmp19_ = !get_has_body;
				} else {
					_tmp19_ = FALSE;
				}
				_tmp18_ = _tmp19_;
			} else {
				_tmp18_ = FALSE;
			}
			if (_tmp18_) {
				ValaSourceReference* _tmp20_;
				ValaSourceReference* _tmp21_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp20_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp21_ = _tmp20_;
				vala_report_error (_tmp21_, "Property getter must have a body");
			}
			if (get_has_body) {
				gboolean _tmp23_ = FALSE;
				if (has_set) {
					_tmp23_ = !set_has_body;
				} else {
					_tmp23_ = FALSE;
				}
				_tmp22_ = _tmp23_;
			} else {
				_tmp22_ = FALSE;
			}
			if (_tmp22_) {
				ValaSourceReference* _tmp24_;
				ValaSourceReference* _tmp25_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp24_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp25_ = _tmp24_;
				vala_report_error (_tmp25_, "Property setter must have a body");
			}
			if (!get_has_body) {
				_tmp26_ = !set_has_body;
			} else {
				_tmp26_ = FALSE;
			}
			if (_tmp26_) {
				const gchar* _tmp27_;
				const gchar* _tmp28_;
				gchar* _tmp29_;
				gchar* _tmp30_;
				ValaDataType* _tmp31_;
				ValaDataType* _tmp32_;
				ValaDataType* _tmp33_;
				ValaDataType* _tmp34_;
				ValaExpression* _tmp35_;
				ValaExpression* _tmp36_;
				ValaSourceReference* _tmp37_;
				ValaSourceReference* _tmp38_;
				ValaField* _tmp39_;
				ValaField* _tmp40_;
				ValaField* _tmp41_;
				ValaMemberBinding _tmp42_;
				ValaAttribute* _tmp43_;
				_tmp27_ = vala_symbol_get_name ((ValaSymbol*) self);
				_tmp28_ = _tmp27_;
				_tmp29_ = g_strdup_printf ("_%s", _tmp28_);
				_tmp30_ = _tmp29_;
				_tmp31_ = vala_property_get_property_type (self);
				_tmp32_ = _tmp31_;
				_tmp33_ = vala_data_type_copy (_tmp32_);
				_tmp34_ = _tmp33_;
				_tmp35_ = vala_property_get_initializer (self);
				_tmp36_ = _tmp35_;
				_tmp37_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp38_ = _tmp37_;
				_tmp39_ = vala_field_new (_tmp30_, _tmp34_, _tmp36_, _tmp38_, NULL);
				_vala_code_node_unref0 (self->priv->_field);
				self->priv->_field = _tmp39_;
				_vala_code_node_unref0 (_tmp34_);
				_g_free0 (_tmp30_);
				_tmp40_ = self->priv->_field;
				vala_symbol_set_access ((ValaSymbol*) _tmp40_, VALA_SYMBOL_ACCESSIBILITY_PRIVATE);
				_tmp41_ = self->priv->_field;
				_tmp42_ = self->priv->_binding;
				vala_field_set_binding (_tmp41_, _tmp42_);
				_tmp43_ = vala_code_node_get_attribute ((ValaCodeNode*) self, "GtkChild");
				if (_tmp43_ != NULL) {
					ValaField* _tmp44_;
					const gchar* _tmp45_;
					const gchar* _tmp46_;
					gchar* _tmp47_;
					gchar* _tmp48_;
					ValaField* _tmp49_;
					_tmp44_ = self->priv->_field;
					_tmp45_ = vala_symbol_get_name ((ValaSymbol*) self);
					_tmp46_ = _tmp45_;
					_tmp47_ = vala_code_node_get_attribute_string ((ValaCodeNode*) self, "GtkChild", "name", _tmp46_);
					_tmp48_ = _tmp47_;
					vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp44_, "GtkChild", "name", _tmp48_, NULL);
					_g_free0 (_tmp48_);
					_tmp49_ = self->priv->_field;
					vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp49_, "GtkChild", "internal", vala_code_node_get_attribute_bool ((ValaCodeNode*) self, "GtkChild", "internal", FALSE), NULL);
				}
			}
		}
		self->priv->_field_checked = TRUE;
	}
	_tmp50_ = self->priv->_field;
	result = _tmp50_;
	return result;
}

ValaMemberBinding
vala_property_get_binding (ValaProperty* self)
{
	ValaMemberBinding result;
	ValaMemberBinding _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_binding;
	result = _tmp0_;
	return result;
}

void
vala_property_set_binding (ValaProperty* self,
                           ValaMemberBinding value)
{
	g_return_if_fail (self != NULL);
	self->priv->_binding = value;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch21_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch21_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally21;
	__catch21_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally21:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

const gchar*
vala_property_get_nick (ValaProperty* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	const gchar* _tmp6_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_nick;
	if (_tmp0_ == NULL) {
		gchar* _tmp1_;
		const gchar* _tmp2_;
		_tmp1_ = vala_code_node_get_attribute_string ((ValaCodeNode*) self, "Description", "nick", NULL);
		_g_free0 (self->priv->_nick);
		self->priv->_nick = _tmp1_;
		_tmp2_ = self->priv->_nick;
		if (_tmp2_ == NULL) {
			const gchar* _tmp3_;
			const gchar* _tmp4_;
			gchar* _tmp5_;
			_tmp3_ = vala_symbol_get_name ((ValaSymbol*) self);
			_tmp4_ = _tmp3_;
			_tmp5_ = string_replace (_tmp4_, "_", "-");
			_g_free0 (self->priv->_nick);
			self->priv->_nick = _tmp5_;
		}
	}
	_tmp6_ = self->priv->_nick;
	result = _tmp6_;
	return result;
}

const gchar*
vala_property_get_blurb (ValaProperty* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	const gchar* _tmp6_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_blurb;
	if (_tmp0_ == NULL) {
		gchar* _tmp1_;
		const gchar* _tmp2_;
		_tmp1_ = vala_code_node_get_attribute_string ((ValaCodeNode*) self, "Description", "blurb", NULL);
		_g_free0 (self->priv->_blurb);
		self->priv->_blurb = _tmp1_;
		_tmp2_ = self->priv->_blurb;
		if (_tmp2_ == NULL) {
			const gchar* _tmp3_;
			const gchar* _tmp4_;
			gchar* _tmp5_;
			_tmp3_ = vala_symbol_get_name ((ValaSymbol*) self);
			_tmp4_ = _tmp3_;
			_tmp5_ = string_replace (_tmp4_, "_", "-");
			_g_free0 (self->priv->_blurb);
			self->priv->_blurb = _tmp5_;
		}
	}
	_tmp6_ = self->priv->_blurb;
	result = _tmp6_;
	return result;
}

static gboolean*
_bool_dup (gboolean* self)
{
	gboolean* dup;
	dup = g_new0 (gboolean, 1);
	memcpy (dup, self, sizeof (gboolean));
	return dup;
}

static gpointer
__bool_dup0 (gpointer self)
{
	return self ? _bool_dup (self) : NULL;
}

gboolean
vala_property_get_notify (ValaProperty* self)
{
	gboolean result;
	gboolean* _tmp0_;
	gboolean* _tmp3_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_notify;
	if (_tmp0_ == NULL) {
		gboolean _tmp1_;
		gboolean* _tmp2_;
		_tmp1_ = vala_code_node_get_attribute_bool ((ValaCodeNode*) self, "CCode", "notify", TRUE);
		_tmp2_ = __bool_dup0 (&_tmp1_);
		_g_free0 (self->priv->_notify);
		self->priv->_notify = _tmp2_;
	}
	_tmp3_ = self->priv->_notify;
	result = *_tmp3_;
	return result;
}

ValaProperty*
vala_property_get_base_property (ValaProperty* self)
{
	ValaProperty* result;
	ValaProperty* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	vala_property_find_base_properties (self);
	_tmp0_ = self->priv->_base_property;
	result = _tmp0_;
	return result;
}

ValaProperty*
vala_property_get_base_interface_property (ValaProperty* self)
{
	ValaProperty* result;
	ValaProperty* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	vala_property_find_base_properties (self);
	_tmp0_ = self->priv->_base_interface_property;
	result = _tmp0_;
	return result;
}

ValaExpression*
vala_property_get_initializer (ValaProperty* self)
{
	ValaExpression* result;
	ValaExpression* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_initializer;
	result = _tmp0_;
	return result;
}

void
vala_property_set_initializer (ValaProperty* self,
                               ValaExpression* value)
{
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_initializer);
	self->priv->_initializer = _tmp0_;
	_tmp1_ = self->priv->_initializer;
	vala_code_node_set_parent_node ((ValaCodeNode*) _tmp1_, (ValaCodeNode*) self);
}

static gboolean
vala_property_real_get_lock_used (ValaLockable* base)
{
	gboolean result;
	ValaProperty* self;
	self = (ValaProperty*) base;
	result = self->priv->_lock_used;
	return result;
}

static void
vala_property_real_set_lock_used (ValaLockable* base,
                                  gboolean value)
{
	ValaProperty* self;
	self = (ValaProperty*) base;
	self->priv->_lock_used = value;
}

/**
 * Creates a new property.
 *
 * @param name              property name
 * @param property_type     property type
 * @param get_accessor      get accessor
 * @param set_accessor      set/construct accessor
 * @param source_reference  reference to source code
 * @return                  newly created property
 */
ValaProperty*
vala_property_construct (GType object_type,
                         const gchar* name,
                         ValaDataType* property_type,
                         ValaPropertyAccessor* get_accessor,
                         ValaPropertyAccessor* set_accessor,
                         ValaSourceReference* source_reference,
                         ValaComment* comment)
{
	ValaProperty* self = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	self = (ValaProperty*) vala_symbol_construct (object_type, name, source_reference, comment);
	vala_property_set_property_type (self, property_type);
	vala_property_set_get_accessor (self, get_accessor);
	vala_property_set_set_accessor (self, set_accessor);
	return self;
}

ValaProperty*
vala_property_new (const gchar* name,
                   ValaDataType* property_type,
                   ValaPropertyAccessor* get_accessor,
                   ValaPropertyAccessor* set_accessor,
                   ValaSourceReference* source_reference,
                   ValaComment* comment)
{
	return vala_property_construct (VALA_TYPE_PROPERTY, name, property_type, get_accessor, set_accessor, source_reference, comment);
}

static void
vala_property_real_accept (ValaCodeNode* base,
                           ValaCodeVisitor* visitor)
{
	ValaProperty * self;
	self = (ValaProperty*) base;
	g_return_if_fail (visitor != NULL);
	vala_code_visitor_visit_property (visitor, self);
}

static void
vala_property_real_accept_children (ValaCodeNode* base,
                                    ValaCodeVisitor* visitor)
{
	ValaProperty * self;
	ValaDataType* _tmp0_;
	ValaDataType* _tmp1_;
	ValaPropertyAccessor* _tmp2_;
	ValaPropertyAccessor* _tmp3_;
	ValaPropertyAccessor* _tmp6_;
	ValaPropertyAccessor* _tmp7_;
	ValaExpression* _tmp10_;
	ValaExpression* _tmp11_;
	self = (ValaProperty*) base;
	g_return_if_fail (visitor != NULL);
	_tmp0_ = vala_property_get_property_type (self);
	_tmp1_ = _tmp0_;
	vala_code_node_accept ((ValaCodeNode*) _tmp1_, visitor);
	_tmp2_ = vala_property_get_get_accessor (self);
	_tmp3_ = _tmp2_;
	if (_tmp3_ != NULL) {
		ValaPropertyAccessor* _tmp4_;
		ValaPropertyAccessor* _tmp5_;
		_tmp4_ = vala_property_get_get_accessor (self);
		_tmp5_ = _tmp4_;
		vala_code_node_accept ((ValaCodeNode*) _tmp5_, visitor);
	}
	_tmp6_ = vala_property_get_set_accessor (self);
	_tmp7_ = _tmp6_;
	if (_tmp7_ != NULL) {
		ValaPropertyAccessor* _tmp8_;
		ValaPropertyAccessor* _tmp9_;
		_tmp8_ = vala_property_get_set_accessor (self);
		_tmp9_ = _tmp8_;
		vala_code_node_accept ((ValaCodeNode*) _tmp9_, visitor);
	}
	_tmp10_ = vala_property_get_initializer (self);
	_tmp11_ = _tmp10_;
	if (_tmp11_ != NULL) {
		ValaExpression* _tmp12_;
		ValaExpression* _tmp13_;
		_tmp12_ = vala_property_get_initializer (self);
		_tmp13_ = _tmp12_;
		vala_code_node_accept ((ValaCodeNode*) _tmp13_, visitor);
	}
}

/**
 * Checks whether the accessors of this property are compatible
 * with the specified base property.
 *
 * @param base_property a property
 * @param invalid_match error string about which check failed
 * @return true if the specified property is compatible to this property
 */
gboolean
vala_property_compatible (ValaProperty* self,
                          ValaProperty* base_property,
                          gchar* * invalid_match)
{
	gchar* _vala_invalid_match = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	ValaPropertyAccessor* _tmp2_;
	ValaPropertyAccessor* _tmp3_;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	ValaPropertyAccessor* _tmp14_;
	ValaPropertyAccessor* _tmp15_;
	ValaDataType* object_type = NULL;
	ValaSymbol* _tmp24_;
	ValaSymbol* _tmp25_;
	ValaDataType* _tmp26_;
	ValaPropertyAccessor* _tmp27_;
	ValaPropertyAccessor* _tmp28_;
	ValaPropertyAccessor* _tmp41_;
	ValaPropertyAccessor* _tmp42_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (base_property != NULL, FALSE);
	_tmp2_ = vala_property_get_get_accessor (self);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == NULL) {
		ValaPropertyAccessor* _tmp4_;
		ValaPropertyAccessor* _tmp5_;
		_tmp4_ = vala_property_get_get_accessor (base_property);
		_tmp5_ = _tmp4_;
		_tmp1_ = _tmp5_ != NULL;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp6_ = FALSE;
		ValaPropertyAccessor* _tmp7_;
		ValaPropertyAccessor* _tmp8_;
		_tmp7_ = vala_property_get_get_accessor (self);
		_tmp8_ = _tmp7_;
		if (_tmp8_ != NULL) {
			ValaPropertyAccessor* _tmp9_;
			ValaPropertyAccessor* _tmp10_;
			_tmp9_ = vala_property_get_get_accessor (base_property);
			_tmp10_ = _tmp9_;
			_tmp6_ = _tmp10_ == NULL;
		} else {
			_tmp6_ = FALSE;
		}
		_tmp0_ = _tmp6_;
	}
	if (_tmp0_) {
		gchar* _tmp11_;
		_tmp11_ = g_strdup ("incompatible get accessor");
		_g_free0 (_vala_invalid_match);
		_vala_invalid_match = _tmp11_;
		result = FALSE;
		if (invalid_match) {
			*invalid_match = _vala_invalid_match;
		} else {
			_g_free0 (_vala_invalid_match);
		}
		return result;
	}
	_tmp14_ = vala_property_get_set_accessor (self);
	_tmp15_ = _tmp14_;
	if (_tmp15_ == NULL) {
		ValaPropertyAccessor* _tmp16_;
		ValaPropertyAccessor* _tmp17_;
		_tmp16_ = vala_property_get_set_accessor (base_property);
		_tmp17_ = _tmp16_;
		_tmp13_ = _tmp17_ != NULL;
	} else {
		_tmp13_ = FALSE;
	}
	if (_tmp13_) {
		_tmp12_ = TRUE;
	} else {
		gboolean _tmp18_ = FALSE;
		ValaPropertyAccessor* _tmp19_;
		ValaPropertyAccessor* _tmp20_;
		_tmp19_ = vala_property_get_set_accessor (self);
		_tmp20_ = _tmp19_;
		if (_tmp20_ != NULL) {
			ValaPropertyAccessor* _tmp21_;
			ValaPropertyAccessor* _tmp22_;
			_tmp21_ = vala_property_get_set_accessor (base_property);
			_tmp22_ = _tmp21_;
			_tmp18_ = _tmp22_ == NULL;
		} else {
			_tmp18_ = FALSE;
		}
		_tmp12_ = _tmp18_;
	}
	if (_tmp12_) {
		gchar* _tmp23_;
		_tmp23_ = g_strdup ("incompatible set accessor");
		_g_free0 (_vala_invalid_match);
		_vala_invalid_match = _tmp23_;
		result = FALSE;
		if (invalid_match) {
			*invalid_match = _vala_invalid_match;
		} else {
			_g_free0 (_vala_invalid_match);
		}
		return result;
	}
	_tmp24_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
	_tmp25_ = _tmp24_;
	_tmp26_ = vala_semantic_analyzer_get_data_type_for_symbol (_tmp25_);
	object_type = _tmp26_;
	_tmp27_ = vala_property_get_get_accessor (self);
	_tmp28_ = _tmp27_;
	if (_tmp28_ != NULL) {
		ValaDataType* actual_base_type = NULL;
		ValaPropertyAccessor* _tmp29_;
		ValaPropertyAccessor* _tmp30_;
		ValaDataType* _tmp31_;
		ValaDataType* _tmp32_;
		ValaDataType* _tmp33_;
		ValaDataType* _tmp34_;
		ValaDataType* _tmp35_;
		ValaPropertyAccessor* _tmp36_;
		ValaPropertyAccessor* _tmp37_;
		ValaDataType* _tmp38_;
		ValaDataType* _tmp39_;
		_tmp29_ = vala_property_get_get_accessor (base_property);
		_tmp30_ = _tmp29_;
		_tmp31_ = vala_property_accessor_get_value_type (_tmp30_);
		_tmp32_ = _tmp31_;
		_tmp33_ = object_type;
		_tmp34_ = vala_data_type_get_actual_type (_tmp32_, _tmp33_, NULL, (ValaCodeNode*) self);
		actual_base_type = _tmp34_;
		_tmp35_ = actual_base_type;
		_tmp36_ = vala_property_get_get_accessor (self);
		_tmp37_ = _tmp36_;
		_tmp38_ = vala_property_accessor_get_value_type (_tmp37_);
		_tmp39_ = _tmp38_;
		if (!vala_data_type_equals (_tmp35_, _tmp39_)) {
			gchar* _tmp40_;
			_tmp40_ = g_strdup ("incompatible get accessor type");
			_g_free0 (_vala_invalid_match);
			_vala_invalid_match = _tmp40_;
			result = FALSE;
			_vala_code_node_unref0 (actual_base_type);
			_vala_code_node_unref0 (object_type);
			if (invalid_match) {
				*invalid_match = _vala_invalid_match;
			} else {
				_g_free0 (_vala_invalid_match);
			}
			return result;
		}
		_vala_code_node_unref0 (actual_base_type);
	}
	_tmp41_ = vala_property_get_set_accessor (self);
	_tmp42_ = _tmp41_;
	if (_tmp42_ != NULL) {
		ValaDataType* actual_base_type = NULL;
		ValaPropertyAccessor* _tmp43_;
		ValaPropertyAccessor* _tmp44_;
		ValaDataType* _tmp45_;
		ValaDataType* _tmp46_;
		ValaDataType* _tmp47_;
		ValaDataType* _tmp48_;
		ValaDataType* _tmp49_;
		ValaPropertyAccessor* _tmp50_;
		ValaPropertyAccessor* _tmp51_;
		ValaDataType* _tmp52_;
		ValaDataType* _tmp53_;
		ValaPropertyAccessor* _tmp55_;
		ValaPropertyAccessor* _tmp56_;
		gboolean _tmp57_;
		gboolean _tmp58_;
		ValaPropertyAccessor* _tmp59_;
		ValaPropertyAccessor* _tmp60_;
		gboolean _tmp61_;
		gboolean _tmp62_;
		ValaPropertyAccessor* _tmp64_;
		ValaPropertyAccessor* _tmp65_;
		gboolean _tmp66_;
		gboolean _tmp67_;
		ValaPropertyAccessor* _tmp68_;
		ValaPropertyAccessor* _tmp69_;
		gboolean _tmp70_;
		gboolean _tmp71_;
		_tmp43_ = vala_property_get_set_accessor (base_property);
		_tmp44_ = _tmp43_;
		_tmp45_ = vala_property_accessor_get_value_type (_tmp44_);
		_tmp46_ = _tmp45_;
		_tmp47_ = object_type;
		_tmp48_ = vala_data_type_get_actual_type (_tmp46_, _tmp47_, NULL, (ValaCodeNode*) self);
		actual_base_type = _tmp48_;
		_tmp49_ = actual_base_type;
		_tmp50_ = vala_property_get_set_accessor (self);
		_tmp51_ = _tmp50_;
		_tmp52_ = vala_property_accessor_get_value_type (_tmp51_);
		_tmp53_ = _tmp52_;
		if (!vala_data_type_equals (_tmp49_, _tmp53_)) {
			gchar* _tmp54_;
			_tmp54_ = g_strdup ("incompatible set accessor type");
			_g_free0 (_vala_invalid_match);
			_vala_invalid_match = _tmp54_;
			result = FALSE;
			_vala_code_node_unref0 (actual_base_type);
			_vala_code_node_unref0 (object_type);
			if (invalid_match) {
				*invalid_match = _vala_invalid_match;
			} else {
				_g_free0 (_vala_invalid_match);
			}
			return result;
		}
		_tmp55_ = vala_property_get_set_accessor (self);
		_tmp56_ = _tmp55_;
		_tmp57_ = vala_property_accessor_get_writable (_tmp56_);
		_tmp58_ = _tmp57_;
		_tmp59_ = vala_property_get_set_accessor (base_property);
		_tmp60_ = _tmp59_;
		_tmp61_ = vala_property_accessor_get_writable (_tmp60_);
		_tmp62_ = _tmp61_;
		if (_tmp58_ != _tmp62_) {
			gchar* _tmp63_;
			_tmp63_ = g_strdup ("incompatible set accessor");
			_g_free0 (_vala_invalid_match);
			_vala_invalid_match = _tmp63_;
			result = FALSE;
			_vala_code_node_unref0 (actual_base_type);
			_vala_code_node_unref0 (object_type);
			if (invalid_match) {
				*invalid_match = _vala_invalid_match;
			} else {
				_g_free0 (_vala_invalid_match);
			}
			return result;
		}
		_tmp64_ = vala_property_get_set_accessor (self);
		_tmp65_ = _tmp64_;
		_tmp66_ = vala_property_accessor_get_construction (_tmp65_);
		_tmp67_ = _tmp66_;
		_tmp68_ = vala_property_get_set_accessor (base_property);
		_tmp69_ = _tmp68_;
		_tmp70_ = vala_property_accessor_get_construction (_tmp69_);
		_tmp71_ = _tmp70_;
		if (_tmp67_ != _tmp71_) {
			gchar* _tmp72_;
			_tmp72_ = g_strdup ("incompatible set accessor");
			_g_free0 (_vala_invalid_match);
			_vala_invalid_match = _tmp72_;
			result = FALSE;
			_vala_code_node_unref0 (actual_base_type);
			_vala_code_node_unref0 (object_type);
			if (invalid_match) {
				*invalid_match = _vala_invalid_match;
			} else {
				_g_free0 (_vala_invalid_match);
			}
			return result;
		}
		_vala_code_node_unref0 (actual_base_type);
	}
	_g_free0 (_vala_invalid_match);
	_vala_invalid_match = NULL;
	result = TRUE;
	_vala_code_node_unref0 (object_type);
	if (invalid_match) {
		*invalid_match = _vala_invalid_match;
	} else {
		_g_free0 (_vala_invalid_match);
	}
	return result;
}

static void
vala_property_real_replace_type (ValaCodeNode* base,
                                 ValaDataType* old_type,
                                 ValaDataType* new_type)
{
	ValaProperty * self;
	ValaDataType* _tmp0_;
	ValaDataType* _tmp1_;
	self = (ValaProperty*) base;
	g_return_if_fail (old_type != NULL);
	g_return_if_fail (new_type != NULL);
	_tmp0_ = vala_property_get_property_type (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == old_type) {
		vala_property_set_property_type (self, new_type);
	}
}

static void
vala_property_real_replace_expression (ValaCodeNode* base,
                                       ValaExpression* old_node,
                                       ValaExpression* new_node)
{
	ValaProperty * self;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	self = (ValaProperty*) base;
	g_return_if_fail (old_node != NULL);
	g_return_if_fail (new_node != NULL);
	_tmp0_ = vala_property_get_initializer (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == old_node) {
		vala_property_set_initializer (self, new_node);
	}
}

static void
vala_property_find_base_properties (ValaProperty* self)
{
	ValaSymbol* _tmp0_;
	ValaSymbol* _tmp1_;
	g_return_if_fail (self != NULL);
	if (self->priv->base_properties_valid) {
		return;
	}
	_tmp0_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
	_tmp1_ = _tmp0_;
	if (VALA_IS_CLASS (_tmp1_)) {
		ValaSymbol* _tmp2_;
		ValaSymbol* _tmp3_;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_;
		_tmp2_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
		_tmp3_ = _tmp2_;
		vala_property_find_base_interface_property (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, VALA_TYPE_CLASS, ValaClass));
		_tmp5_ = self->priv->_is_virtual;
		if (_tmp5_) {
			_tmp4_ = TRUE;
		} else {
			gboolean _tmp6_;
			_tmp6_ = self->priv->_overrides;
			_tmp4_ = _tmp6_;
		}
		if (_tmp4_) {
			ValaSymbol* _tmp7_;
			ValaSymbol* _tmp8_;
			_tmp7_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
			_tmp8_ = _tmp7_;
			vala_property_find_base_class_property (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, VALA_TYPE_CLASS, ValaClass));
		}
	} else {
		ValaSymbol* _tmp9_;
		ValaSymbol* _tmp10_;
		_tmp9_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
		_tmp10_ = _tmp9_;
		if (VALA_IS_INTERFACE (_tmp10_)) {
			gboolean _tmp11_ = FALSE;
			gboolean _tmp12_;
			_tmp12_ = self->priv->_is_virtual;
			if (_tmp12_) {
				_tmp11_ = TRUE;
			} else {
				gboolean _tmp13_;
				_tmp13_ = self->priv->_is_abstract;
				_tmp11_ = _tmp13_;
			}
			if (_tmp11_) {
				ValaProperty* _tmp14_;
				_tmp14_ = _vala_code_node_ref0 (self);
				_vala_code_node_unref0 (self->priv->_base_interface_property);
				self->priv->_base_interface_property = _tmp14_;
			}
		}
	}
	self->priv->base_properties_valid = TRUE;
}

static void
vala_property_find_base_class_property (ValaProperty* self,
                                        ValaClass* cl)
{
	ValaSymbol* sym = NULL;
	ValaScope* _tmp0_;
	ValaScope* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	ValaSymbol* _tmp4_;
	ValaSymbol* _tmp5_;
	ValaClass* _tmp27_;
	ValaClass* _tmp28_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cl != NULL);
	_tmp0_ = vala_symbol_get_scope ((ValaSymbol*) cl);
	_tmp1_ = _tmp0_;
	_tmp2_ = vala_symbol_get_name ((ValaSymbol*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = vala_scope_lookup (_tmp1_, _tmp3_);
	sym = _tmp4_;
	_tmp5_ = sym;
	if (VALA_IS_PROPERTY (_tmp5_)) {
		ValaProperty* base_property = NULL;
		ValaSymbol* _tmp6_;
		ValaProperty* _tmp7_;
		gboolean _tmp8_ = FALSE;
		ValaProperty* _tmp9_;
		gboolean _tmp10_;
		_tmp6_ = sym;
		_tmp7_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, VALA_TYPE_PROPERTY, ValaProperty));
		base_property = _tmp7_;
		_tmp9_ = base_property;
		_tmp10_ = _tmp9_->priv->_is_abstract;
		if (_tmp10_) {
			_tmp8_ = TRUE;
		} else {
			ValaProperty* _tmp11_;
			gboolean _tmp12_;
			_tmp11_ = base_property;
			_tmp12_ = _tmp11_->priv->_is_virtual;
			_tmp8_ = _tmp12_;
		}
		if (_tmp8_) {
			gchar* invalid_match = NULL;
			ValaProperty* _tmp13_;
			gchar* _tmp14_ = NULL;
			gboolean _tmp15_;
			ValaProperty* _tmp26_;
			_tmp13_ = base_property;
			_tmp15_ = vala_property_compatible (self, _tmp13_, &_tmp14_);
			_g_free0 (invalid_match);
			invalid_match = _tmp14_;
			if (!_tmp15_) {
				ValaSourceReference* _tmp16_;
				ValaSourceReference* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				ValaProperty* _tmp20_;
				gchar* _tmp21_;
				gchar* _tmp22_;
				const gchar* _tmp23_;
				gchar* _tmp24_;
				gchar* _tmp25_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp16_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp17_ = _tmp16_;
				_tmp18_ = vala_symbol_get_full_name ((ValaSymbol*) self);
				_tmp19_ = _tmp18_;
				_tmp20_ = base_property;
				_tmp21_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp20_);
				_tmp22_ = _tmp21_;
				_tmp23_ = invalid_match;
				_tmp24_ = g_strdup_printf ("Type and/or accessors of overriding property `%s' do not match overrid" \
"den property `%s': %s.", _tmp19_, _tmp22_, _tmp23_);
				_tmp25_ = _tmp24_;
				vala_report_error (_tmp17_, _tmp25_);
				_g_free0 (_tmp25_);
				_g_free0 (_tmp22_);
				_g_free0 (_tmp19_);
				_g_free0 (invalid_match);
				_vala_code_node_unref0 (base_property);
				_vala_code_node_unref0 (sym);
				return;
			}
			_tmp26_ = base_property;
			self->priv->_base_property = _tmp26_;
			_g_free0 (invalid_match);
			_vala_code_node_unref0 (base_property);
			_vala_code_node_unref0 (sym);
			return;
		}
		_vala_code_node_unref0 (base_property);
	}
	_tmp27_ = vala_class_get_base_class (cl);
	_tmp28_ = _tmp27_;
	if (_tmp28_ != NULL) {
		ValaClass* _tmp29_;
		ValaClass* _tmp30_;
		_tmp29_ = vala_class_get_base_class (cl);
		_tmp30_ = _tmp29_;
		vala_property_find_base_class_property (self, _tmp30_);
	}
	_vala_code_node_unref0 (sym);
}

static gpointer
_vala_iterable_ref0 (gpointer self)
{
	return self ? vala_iterable_ref (self) : NULL;
}

static void
vala_property_find_base_interface_property (ValaProperty* self,
                                            ValaClass* cl)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (cl != NULL);
	{
		ValaList* _type_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _type_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _type_index = 0;
		_tmp0_ = vala_class_get_base_types (cl);
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_type_list = _tmp1_;
		_tmp2_ = _type_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_type_size = _tmp4_;
		_type_index = -1;
		while (TRUE) {
			ValaDataType* type = NULL;
			ValaList* _tmp5_;
			gpointer _tmp6_;
			ValaDataType* _tmp7_;
			ValaTypeSymbol* _tmp8_;
			ValaTypeSymbol* _tmp9_;
			_type_index = _type_index + 1;
			if (!(_type_index < _type_size)) {
				break;
			}
			_tmp5_ = _type_list;
			_tmp6_ = vala_list_get (_tmp5_, _type_index);
			type = (ValaDataType*) _tmp6_;
			_tmp7_ = type;
			_tmp8_ = vala_data_type_get_type_symbol (_tmp7_);
			_tmp9_ = _tmp8_;
			if (VALA_IS_INTERFACE (_tmp9_)) {
				ValaSymbol* sym = NULL;
				ValaDataType* _tmp10_;
				ValaTypeSymbol* _tmp11_;
				ValaTypeSymbol* _tmp12_;
				ValaScope* _tmp13_;
				ValaScope* _tmp14_;
				const gchar* _tmp15_;
				const gchar* _tmp16_;
				ValaSymbol* _tmp17_;
				ValaSymbol* _tmp18_;
				_tmp10_ = type;
				_tmp11_ = vala_data_type_get_type_symbol (_tmp10_);
				_tmp12_ = _tmp11_;
				_tmp13_ = vala_symbol_get_scope ((ValaSymbol*) _tmp12_);
				_tmp14_ = _tmp13_;
				_tmp15_ = vala_symbol_get_name ((ValaSymbol*) self);
				_tmp16_ = _tmp15_;
				_tmp17_ = vala_scope_lookup (_tmp14_, _tmp16_);
				sym = _tmp17_;
				_tmp18_ = sym;
				if (VALA_IS_PROPERTY (_tmp18_)) {
					ValaProperty* base_property = NULL;
					ValaSymbol* _tmp19_;
					ValaProperty* _tmp20_;
					gboolean _tmp21_ = FALSE;
					ValaProperty* _tmp22_;
					gboolean _tmp23_;
					_tmp19_ = sym;
					_tmp20_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, VALA_TYPE_PROPERTY, ValaProperty));
					base_property = _tmp20_;
					_tmp22_ = base_property;
					_tmp23_ = _tmp22_->priv->_is_abstract;
					if (_tmp23_) {
						_tmp21_ = TRUE;
					} else {
						ValaProperty* _tmp24_;
						gboolean _tmp25_;
						_tmp24_ = base_property;
						_tmp25_ = _tmp24_->priv->_is_virtual;
						_tmp21_ = _tmp25_;
					}
					if (_tmp21_) {
						gchar* invalid_match = NULL;
						ValaProperty* _tmp26_;
						gchar* _tmp27_ = NULL;
						gboolean _tmp28_;
						ValaProperty* _tmp39_;
						ValaProperty* _tmp40_;
						_tmp26_ = base_property;
						_tmp28_ = vala_property_compatible (self, _tmp26_, &_tmp27_);
						_g_free0 (invalid_match);
						invalid_match = _tmp27_;
						if (!_tmp28_) {
							ValaSourceReference* _tmp29_;
							ValaSourceReference* _tmp30_;
							gchar* _tmp31_;
							gchar* _tmp32_;
							ValaProperty* _tmp33_;
							gchar* _tmp34_;
							gchar* _tmp35_;
							const gchar* _tmp36_;
							gchar* _tmp37_;
							gchar* _tmp38_;
							vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
							_tmp29_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
							_tmp30_ = _tmp29_;
							_tmp31_ = vala_symbol_get_full_name ((ValaSymbol*) self);
							_tmp32_ = _tmp31_;
							_tmp33_ = base_property;
							_tmp34_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp33_);
							_tmp35_ = _tmp34_;
							_tmp36_ = invalid_match;
							_tmp37_ = g_strdup_printf ("Type and/or accessors of overriding property `%s' do not match overrid" \
"den property `%s': %s.", _tmp32_, _tmp35_, _tmp36_);
							_tmp38_ = _tmp37_;
							vala_report_error (_tmp30_, _tmp38_);
							_g_free0 (_tmp38_);
							_g_free0 (_tmp35_);
							_g_free0 (_tmp32_);
							_g_free0 (invalid_match);
							_vala_code_node_unref0 (base_property);
							_vala_code_node_unref0 (sym);
							_vala_code_node_unref0 (type);
							_vala_iterable_unref0 (_type_list);
							return;
						}
						_tmp39_ = base_property;
						_tmp40_ = _vala_code_node_ref0 (_tmp39_);
						_vala_code_node_unref0 (self->priv->_base_interface_property);
						self->priv->_base_interface_property = _tmp40_;
						_g_free0 (invalid_match);
						_vala_code_node_unref0 (base_property);
						_vala_code_node_unref0 (sym);
						_vala_code_node_unref0 (type);
						_vala_iterable_unref0 (_type_list);
						return;
					}
					_vala_code_node_unref0 (base_property);
				}
				_vala_code_node_unref0 (sym);
			}
			_vala_code_node_unref0 (type);
		}
		_vala_iterable_unref0 (_type_list);
	}
}

static gpointer
_vala_source_file_ref0 (gpointer self)
{
	return self ? vala_source_file_ref (self) : NULL;
}

static gboolean
vala_property_real_check (ValaCodeNode* base,
                          ValaCodeContext* context)
{
	ValaProperty * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp4_ = FALSE;
	ValaSymbol* _tmp5_;
	ValaSymbol* _tmp6_;
	gboolean _tmp22_;
	ValaSourceFile* old_source_file = NULL;
	ValaSemanticAnalyzer* _tmp59_;
	ValaSemanticAnalyzer* _tmp60_;
	ValaSourceFile* _tmp61_;
	ValaSourceFile* _tmp62_;
	ValaSourceFile* _tmp63_;
	ValaSymbol* old_symbol = NULL;
	ValaSemanticAnalyzer* _tmp64_;
	ValaSemanticAnalyzer* _tmp65_;
	ValaSymbol* _tmp66_;
	ValaSymbol* _tmp67_;
	ValaSymbol* _tmp68_;
	ValaSourceReference* _tmp69_;
	ValaSourceReference* _tmp70_;
	ValaSemanticAnalyzer* _tmp77_;
	ValaSemanticAnalyzer* _tmp78_;
	ValaDataType* _tmp79_;
	ValaDataType* _tmp80_;
	ValaDataType* _tmp83_;
	ValaDataType* _tmp84_;
	gboolean _tmp85_;
	gboolean _tmp86_;
	gboolean _tmp91_ = FALSE;
	ValaPropertyAccessor* _tmp92_;
	ValaPropertyAccessor* _tmp93_;
	ValaPropertyAccessor* _tmp102_;
	ValaPropertyAccessor* _tmp103_;
	ValaPropertyAccessor* _tmp106_;
	ValaPropertyAccessor* _tmp107_;
	gboolean _tmp110_ = FALSE;
	gboolean _tmp111_ = FALSE;
	ValaExpression* _tmp112_;
	ValaExpression* _tmp113_;
	ValaExpression* _tmp123_;
	ValaExpression* _tmp124_;
	ValaSemanticAnalyzer* _tmp127_;
	ValaSemanticAnalyzer* _tmp128_;
	ValaDataType* _tmp129_;
	ValaDataType* _tmp130_;
	gboolean _tmp141_ = FALSE;
	gboolean _tmp142_;
	gboolean _tmp151_ = FALSE;
	gboolean _tmp152_ = FALSE;
	gboolean _tmp153_ = FALSE;
	gboolean _tmp154_;
	gboolean _tmp155_;
	gboolean _tmp171_ = FALSE;
	ValaPropertyAccessor* _tmp172_;
	ValaPropertyAccessor* _tmp173_;
	gboolean _tmp186_ = FALSE;
	gboolean _tmp187_ = FALSE;
	gboolean _tmp188_ = FALSE;
	ValaExpression* _tmp189_;
	ValaExpression* _tmp190_;
	ValaSemanticAnalyzer* _tmp221_;
	ValaSemanticAnalyzer* _tmp222_;
	ValaSourceFile* _tmp223_;
	ValaSemanticAnalyzer* _tmp224_;
	ValaSemanticAnalyzer* _tmp225_;
	ValaSymbol* _tmp226_;
	gboolean _tmp227_;
	gboolean _tmp228_;
	gboolean result = FALSE;
	self = (ValaProperty*) base;
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp0_ = vala_code_node_get_checked ((ValaCodeNode*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = vala_code_node_get_error ((ValaCodeNode*) self);
		_tmp3_ = _tmp2_;
		result = !_tmp3_;
		return result;
	}
	vala_code_node_set_checked ((ValaCodeNode*) self, TRUE);
	_tmp5_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
	_tmp6_ = _tmp5_;
	if (VALA_IS_CLASS (_tmp6_)) {
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_;
		_tmp8_ = self->priv->_is_abstract;
		if (_tmp8_) {
			_tmp7_ = TRUE;
		} else {
			gboolean _tmp9_;
			_tmp9_ = self->priv->_is_virtual;
			_tmp7_ = _tmp9_;
		}
		_tmp4_ = _tmp7_;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		ValaClass* cl = NULL;
		ValaSymbol* _tmp10_;
		ValaSymbol* _tmp11_;
		ValaClass* _tmp12_;
		gboolean _tmp13_ = FALSE;
		ValaClass* _tmp14_;
		gboolean _tmp15_;
		gboolean _tmp16_;
		_tmp10_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
		_tmp11_ = _tmp10_;
		_tmp12_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, VALA_TYPE_CLASS, ValaClass));
		cl = _tmp12_;
		_tmp14_ = cl;
		_tmp15_ = vala_class_get_is_compact (_tmp14_);
		_tmp16_ = _tmp15_;
		if (_tmp16_) {
			ValaClass* _tmp17_;
			ValaClass* _tmp18_;
			ValaClass* _tmp19_;
			_tmp17_ = cl;
			_tmp18_ = vala_class_get_base_class (_tmp17_);
			_tmp19_ = _tmp18_;
			_tmp13_ = _tmp19_ != NULL;
		} else {
			_tmp13_ = FALSE;
		}
		if (_tmp13_) {
			ValaSourceReference* _tmp20_;
			ValaSourceReference* _tmp21_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp20_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp21_ = _tmp20_;
			vala_report_error (_tmp21_, "Abstract and virtual properties may not be declared in derived compact" \
" classes");
			result = FALSE;
			_vala_code_node_unref0 (cl);
			return result;
		}
		_vala_code_node_unref0 (cl);
	}
	_tmp22_ = self->priv->_is_abstract;
	if (_tmp22_) {
		ValaSymbol* _tmp23_;
		ValaSymbol* _tmp24_;
		_tmp23_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
		_tmp24_ = _tmp23_;
		if (VALA_IS_CLASS (_tmp24_)) {
			ValaClass* cl = NULL;
			ValaSymbol* _tmp25_;
			ValaSymbol* _tmp26_;
			ValaClass* _tmp27_;
			ValaClass* _tmp28_;
			gboolean _tmp29_;
			gboolean _tmp30_;
			_tmp25_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
			_tmp26_ = _tmp25_;
			_tmp27_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, VALA_TYPE_CLASS, ValaClass));
			cl = _tmp27_;
			_tmp28_ = cl;
			_tmp29_ = vala_class_get_is_abstract (_tmp28_);
			_tmp30_ = _tmp29_;
			if (!_tmp30_) {
				ValaSourceReference* _tmp31_;
				ValaSourceReference* _tmp32_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp31_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp32_ = _tmp31_;
				vala_report_error (_tmp32_, "Abstract properties may not be declared in non-abstract classes");
				result = FALSE;
				_vala_code_node_unref0 (cl);
				return result;
			}
			_vala_code_node_unref0 (cl);
		} else {
			ValaSymbol* _tmp33_;
			ValaSymbol* _tmp34_;
			_tmp33_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
			_tmp34_ = _tmp33_;
			if (!VALA_IS_INTERFACE (_tmp34_)) {
				ValaSourceReference* _tmp35_;
				ValaSourceReference* _tmp36_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp35_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp36_ = _tmp35_;
				vala_report_error (_tmp36_, "Abstract properties may not be declared outside of classes and interfa" \
"ces");
				result = FALSE;
				return result;
			}
		}
	} else {
		gboolean _tmp37_;
		_tmp37_ = self->priv->_is_virtual;
		if (_tmp37_) {
			gboolean _tmp38_ = FALSE;
			ValaSymbol* _tmp39_;
			ValaSymbol* _tmp40_;
			_tmp39_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
			_tmp40_ = _tmp39_;
			if (!VALA_IS_CLASS (_tmp40_)) {
				ValaSymbol* _tmp41_;
				ValaSymbol* _tmp42_;
				_tmp41_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
				_tmp42_ = _tmp41_;
				_tmp38_ = !VALA_IS_INTERFACE (_tmp42_);
			} else {
				_tmp38_ = FALSE;
			}
			if (_tmp38_) {
				ValaSourceReference* _tmp43_;
				ValaSourceReference* _tmp44_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp43_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp44_ = _tmp43_;
				vala_report_error (_tmp44_, "Virtual properties may not be declared outside of classes and interfac" \
"es");
				result = FALSE;
				return result;
			}
		} else {
			gboolean _tmp45_;
			_tmp45_ = self->priv->_overrides;
			if (_tmp45_) {
				ValaSymbol* _tmp46_;
				ValaSymbol* _tmp47_;
				_tmp46_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
				_tmp47_ = _tmp46_;
				if (!VALA_IS_CLASS (_tmp47_)) {
					ValaSourceReference* _tmp48_;
					ValaSourceReference* _tmp49_;
					vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
					_tmp48_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
					_tmp49_ = _tmp48_;
					vala_report_error (_tmp49_, "Properties may not be overridden outside of classes");
					result = FALSE;
					return result;
				}
			} else {
				ValaSymbolAccessibility _tmp50_;
				ValaSymbolAccessibility _tmp51_;
				_tmp50_ = vala_symbol_get_access ((ValaSymbol*) self);
				_tmp51_ = _tmp50_;
				if (_tmp51_ == VALA_SYMBOL_ACCESSIBILITY_PROTECTED) {
					gboolean _tmp52_ = FALSE;
					ValaSymbol* _tmp53_;
					ValaSymbol* _tmp54_;
					_tmp53_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
					_tmp54_ = _tmp53_;
					if (!VALA_IS_CLASS (_tmp54_)) {
						ValaSymbol* _tmp55_;
						ValaSymbol* _tmp56_;
						_tmp55_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
						_tmp56_ = _tmp55_;
						_tmp52_ = !VALA_IS_INTERFACE (_tmp56_);
					} else {
						_tmp52_ = FALSE;
					}
					if (_tmp52_) {
						ValaSourceReference* _tmp57_;
						ValaSourceReference* _tmp58_;
						vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
						_tmp57_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
						_tmp58_ = _tmp57_;
						vala_report_error (_tmp58_, "Protected properties may not be declared outside of classes and interf" \
"aces");
						result = FALSE;
						return result;
					}
				}
			}
		}
	}
	_tmp59_ = vala_code_context_get_analyzer (context);
	_tmp60_ = _tmp59_;
	_tmp61_ = vala_semantic_analyzer_get_current_source_file (_tmp60_);
	_tmp62_ = _tmp61_;
	_tmp63_ = _vala_source_file_ref0 (_tmp62_);
	old_source_file = _tmp63_;
	_tmp64_ = vala_code_context_get_analyzer (context);
	_tmp65_ = _tmp64_;
	_tmp66_ = vala_semantic_analyzer_get_current_symbol (_tmp65_);
	_tmp67_ = _tmp66_;
	_tmp68_ = _vala_code_node_ref0 (_tmp67_);
	old_symbol = _tmp68_;
	_tmp69_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
	_tmp70_ = _tmp69_;
	if (_tmp70_ != NULL) {
		ValaSemanticAnalyzer* _tmp71_;
		ValaSemanticAnalyzer* _tmp72_;
		ValaSourceReference* _tmp73_;
		ValaSourceReference* _tmp74_;
		ValaSourceFile* _tmp75_;
		ValaSourceFile* _tmp76_;
		_tmp71_ = vala_code_context_get_analyzer (context);
		_tmp72_ = _tmp71_;
		_tmp73_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp74_ = _tmp73_;
		_tmp75_ = vala_source_reference_get_file (_tmp74_);
		_tmp76_ = _tmp75_;
		vala_semantic_analyzer_set_current_source_file (_tmp72_, _tmp76_);
	}
	_tmp77_ = vala_code_context_get_analyzer (context);
	_tmp78_ = _tmp77_;
	vala_semantic_analyzer_set_current_symbol (_tmp78_, (ValaSymbol*) self);
	_tmp79_ = vala_property_get_property_type (self);
	_tmp80_ = _tmp79_;
	if (VALA_IS_VOID_TYPE (_tmp80_)) {
		ValaSourceReference* _tmp81_;
		ValaSourceReference* _tmp82_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp81_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp82_ = _tmp81_;
		vala_report_error (_tmp82_, "'void' not supported as property type");
		result = FALSE;
		_vala_code_node_unref0 (old_symbol);
		_vala_source_file_unref0 (old_source_file);
		return result;
	}
	_tmp83_ = vala_property_get_property_type (self);
	_tmp84_ = _tmp83_;
	vala_code_node_check ((ValaCodeNode*) _tmp84_, context);
	_tmp85_ = vala_symbol_get_external_package ((ValaSymbol*) self);
	_tmp86_ = _tmp85_;
	if (!_tmp86_) {
		ValaSemanticAnalyzer* _tmp87_;
		ValaSemanticAnalyzer* _tmp88_;
		ValaDataType* _tmp89_;
		ValaDataType* _tmp90_;
		_tmp87_ = vala_code_context_get_analyzer (context);
		_tmp88_ = _tmp87_;
		_tmp89_ = vala_property_get_property_type (self);
		_tmp90_ = _tmp89_;
		vala_semantic_analyzer_check_type (_tmp88_, _tmp90_);
	}
	_tmp92_ = vala_property_get_get_accessor (self);
	_tmp93_ = _tmp92_;
	if (_tmp93_ == NULL) {
		ValaPropertyAccessor* _tmp94_;
		ValaPropertyAccessor* _tmp95_;
		_tmp94_ = vala_property_get_set_accessor (self);
		_tmp95_ = _tmp94_;
		_tmp91_ = _tmp95_ == NULL;
	} else {
		_tmp91_ = FALSE;
	}
	if (_tmp91_) {
		ValaSourceReference* _tmp96_;
		ValaSourceReference* _tmp97_;
		gchar* _tmp98_;
		gchar* _tmp99_;
		gchar* _tmp100_;
		gchar* _tmp101_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp96_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp97_ = _tmp96_;
		_tmp98_ = vala_symbol_get_full_name ((ValaSymbol*) self);
		_tmp99_ = _tmp98_;
		_tmp100_ = g_strdup_printf ("Property `%s' must have a `get' accessor and/or a `set' mutator", _tmp99_);
		_tmp101_ = _tmp100_;
		vala_report_error (_tmp97_, _tmp101_);
		_g_free0 (_tmp101_);
		_g_free0 (_tmp99_);
		result = FALSE;
		_vala_code_node_unref0 (old_symbol);
		_vala_source_file_unref0 (old_source_file);
		return result;
	}
	_tmp102_ = vala_property_get_get_accessor (self);
	_tmp103_ = _tmp102_;
	if (_tmp103_ != NULL) {
		ValaPropertyAccessor* _tmp104_;
		ValaPropertyAccessor* _tmp105_;
		_tmp104_ = vala_property_get_get_accessor (self);
		_tmp105_ = _tmp104_;
		vala_code_node_check ((ValaCodeNode*) _tmp105_, context);
	}
	_tmp106_ = vala_property_get_set_accessor (self);
	_tmp107_ = _tmp106_;
	if (_tmp107_ != NULL) {
		ValaPropertyAccessor* _tmp108_;
		ValaPropertyAccessor* _tmp109_;
		_tmp108_ = vala_property_get_set_accessor (self);
		_tmp109_ = _tmp108_;
		vala_code_node_check ((ValaCodeNode*) _tmp109_, context);
	}
	_tmp112_ = vala_property_get_initializer (self);
	_tmp113_ = _tmp112_;
	if (_tmp113_ != NULL) {
		ValaField* _tmp114_;
		ValaField* _tmp115_;
		_tmp114_ = vala_property_get_field (self);
		_tmp115_ = _tmp114_;
		_tmp111_ = _tmp115_ == NULL;
	} else {
		_tmp111_ = FALSE;
	}
	if (_tmp111_) {
		gboolean _tmp116_;
		_tmp116_ = self->priv->_is_abstract;
		_tmp110_ = !_tmp116_;
	} else {
		_tmp110_ = FALSE;
	}
	if (_tmp110_) {
		ValaSourceReference* _tmp117_;
		ValaSourceReference* _tmp118_;
		gchar* _tmp119_;
		gchar* _tmp120_;
		gchar* _tmp121_;
		gchar* _tmp122_;
		_tmp117_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp118_ = _tmp117_;
		_tmp119_ = vala_symbol_get_full_name ((ValaSymbol*) self);
		_tmp120_ = _tmp119_;
		_tmp121_ = g_strdup_printf ("Property `%s' with custom `get' accessor and/or `set' mutator cannot h" \
"ave `default' value", _tmp120_);
		_tmp122_ = _tmp121_;
		vala_report_error (_tmp118_, _tmp122_);
		_g_free0 (_tmp122_);
		_g_free0 (_tmp120_);
	}
	_tmp123_ = vala_property_get_initializer (self);
	_tmp124_ = _tmp123_;
	if (_tmp124_ != NULL) {
		ValaExpression* _tmp125_;
		ValaExpression* _tmp126_;
		_tmp125_ = vala_property_get_initializer (self);
		_tmp126_ = _tmp125_;
		vala_code_node_check ((ValaCodeNode*) _tmp126_, context);
	}
	_tmp127_ = vala_code_context_get_analyzer (context);
	_tmp128_ = _tmp127_;
	_tmp129_ = vala_property_get_property_type (self);
	_tmp130_ = _tmp129_;
	if (!vala_semantic_analyzer_is_type_accessible (_tmp128_, (ValaSymbol*) self, _tmp130_)) {
		ValaSourceReference* _tmp131_;
		ValaSourceReference* _tmp132_;
		ValaDataType* _tmp133_;
		ValaDataType* _tmp134_;
		gchar* _tmp135_;
		gchar* _tmp136_;
		gchar* _tmp137_;
		gchar* _tmp138_;
		gchar* _tmp139_;
		gchar* _tmp140_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp131_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp132_ = _tmp131_;
		_tmp133_ = vala_property_get_property_type (self);
		_tmp134_ = _tmp133_;
		_tmp135_ = vala_code_node_to_string ((ValaCodeNode*) _tmp134_);
		_tmp136_ = _tmp135_;
		_tmp137_ = vala_symbol_get_full_name ((ValaSymbol*) self);
		_tmp138_ = _tmp137_;
		_tmp139_ = g_strdup_printf ("property type `%s' is less accessible than property `%s'", _tmp136_, _tmp138_);
		_tmp140_ = _tmp139_;
		vala_report_error (_tmp132_, _tmp140_);
		_g_free0 (_tmp140_);
		_g_free0 (_tmp138_);
		_g_free0 (_tmp136_);
	}
	_tmp142_ = self->priv->_overrides;
	if (_tmp142_) {
		ValaProperty* _tmp143_;
		ValaProperty* _tmp144_;
		_tmp143_ = vala_property_get_base_property (self);
		_tmp144_ = _tmp143_;
		_tmp141_ = _tmp144_ == NULL;
	} else {
		_tmp141_ = FALSE;
	}
	if (_tmp141_) {
		ValaSourceReference* _tmp145_;
		ValaSourceReference* _tmp146_;
		gchar* _tmp147_;
		gchar* _tmp148_;
		gchar* _tmp149_;
		gchar* _tmp150_;
		_tmp145_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp146_ = _tmp145_;
		_tmp147_ = vala_symbol_get_full_name ((ValaSymbol*) self);
		_tmp148_ = _tmp147_;
		_tmp149_ = g_strdup_printf ("%s: no suitable property found to override", _tmp148_);
		_tmp150_ = _tmp149_;
		vala_report_error (_tmp146_, _tmp150_);
		_g_free0 (_tmp150_);
		_g_free0 (_tmp148_);
	}
	_tmp154_ = vala_symbol_get_external_package ((ValaSymbol*) self);
	_tmp155_ = _tmp154_;
	if (!_tmp155_) {
		gboolean _tmp156_;
		_tmp156_ = self->priv->_overrides;
		_tmp153_ = !_tmp156_;
	} else {
		_tmp153_ = FALSE;
	}
	if (_tmp153_) {
		gboolean _tmp157_;
		gboolean _tmp158_;
		_tmp157_ = vala_symbol_get_hides ((ValaSymbol*) self);
		_tmp158_ = _tmp157_;
		_tmp152_ = !_tmp158_;
	} else {
		_tmp152_ = FALSE;
	}
	if (_tmp152_) {
		ValaSymbol* _tmp159_;
		ValaSymbol* _tmp160_;
		_tmp159_ = vala_symbol_get_hidden_member ((ValaSymbol*) self);
		_tmp160_ = _tmp159_;
		_tmp151_ = _tmp160_ != NULL;
		_vala_code_node_unref0 (_tmp160_);
	} else {
		_tmp151_ = FALSE;
	}
	if (_tmp151_) {
		ValaSourceReference* _tmp161_;
		ValaSourceReference* _tmp162_;
		gchar* _tmp163_;
		gchar* _tmp164_;
		ValaSymbol* _tmp165_;
		ValaSymbol* _tmp166_;
		gchar* _tmp167_;
		gchar* _tmp168_;
		gchar* _tmp169_;
		gchar* _tmp170_;
		_tmp161_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp162_ = _tmp161_;
		_tmp163_ = vala_symbol_get_full_name ((ValaSymbol*) self);
		_tmp164_ = _tmp163_;
		_tmp165_ = vala_symbol_get_hidden_member ((ValaSymbol*) self);
		_tmp166_ = _tmp165_;
		_tmp167_ = vala_symbol_get_full_name (_tmp166_);
		_tmp168_ = _tmp167_;
		_tmp169_ = g_strdup_printf ("%s hides inherited property `%s'. Use the `new' keyword if hiding was " \
"intentional", _tmp164_, _tmp168_);
		_tmp170_ = _tmp169_;
		vala_report_warning (_tmp162_, _tmp170_);
		_g_free0 (_tmp170_);
		_g_free0 (_tmp168_);
		_vala_code_node_unref0 (_tmp166_);
		_g_free0 (_tmp164_);
	}
	_tmp172_ = vala_property_get_set_accessor (self);
	_tmp173_ = _tmp172_;
	if (_tmp173_ != NULL) {
		ValaPropertyAccessor* _tmp174_;
		ValaPropertyAccessor* _tmp175_;
		gboolean _tmp176_;
		gboolean _tmp177_;
		_tmp174_ = vala_property_get_set_accessor (self);
		_tmp175_ = _tmp174_;
		_tmp176_ = vala_property_accessor_get_construction (_tmp175_);
		_tmp177_ = _tmp176_;
		_tmp171_ = _tmp177_;
	} else {
		_tmp171_ = FALSE;
	}
	if (_tmp171_) {
		ValaSymbolAccessibility _tmp178_;
		ValaSymbolAccessibility _tmp179_;
		_tmp178_ = vala_symbol_get_access ((ValaSymbol*) self);
		_tmp179_ = _tmp178_;
		if (_tmp179_ != VALA_SYMBOL_ACCESSIBILITY_PUBLIC) {
			ValaSourceReference* _tmp180_;
			ValaSourceReference* _tmp181_;
			gchar* _tmp182_;
			gchar* _tmp183_;
			gchar* _tmp184_;
			gchar* _tmp185_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp180_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp181_ = _tmp180_;
			_tmp182_ = vala_symbol_get_full_name ((ValaSymbol*) self);
			_tmp183_ = _tmp182_;
			_tmp184_ = g_strdup_printf ("%s: construct properties must be public", _tmp183_);
			_tmp185_ = _tmp184_;
			vala_report_error (_tmp181_, _tmp185_);
			_g_free0 (_tmp185_);
			_g_free0 (_tmp183_);
		}
	}
	_tmp189_ = vala_property_get_initializer (self);
	_tmp190_ = _tmp189_;
	if (_tmp190_ != NULL) {
		ValaExpression* _tmp191_;
		ValaExpression* _tmp192_;
		gboolean _tmp193_;
		gboolean _tmp194_;
		_tmp191_ = vala_property_get_initializer (self);
		_tmp192_ = _tmp191_;
		_tmp193_ = vala_code_node_get_error ((ValaCodeNode*) _tmp192_);
		_tmp194_ = _tmp193_;
		_tmp188_ = !_tmp194_;
	} else {
		_tmp188_ = FALSE;
	}
	if (_tmp188_) {
		ValaExpression* _tmp195_;
		ValaExpression* _tmp196_;
		ValaDataType* _tmp197_;
		ValaDataType* _tmp198_;
		_tmp195_ = vala_property_get_initializer (self);
		_tmp196_ = _tmp195_;
		_tmp197_ = vala_expression_get_value_type (_tmp196_);
		_tmp198_ = _tmp197_;
		_tmp187_ = _tmp198_ != NULL;
	} else {
		_tmp187_ = FALSE;
	}
	if (_tmp187_) {
		ValaExpression* _tmp199_;
		ValaExpression* _tmp200_;
		ValaDataType* _tmp201_;
		ValaDataType* _tmp202_;
		ValaDataType* _tmp203_;
		ValaDataType* _tmp204_;
		_tmp199_ = vala_property_get_initializer (self);
		_tmp200_ = _tmp199_;
		_tmp201_ = vala_expression_get_value_type (_tmp200_);
		_tmp202_ = _tmp201_;
		_tmp203_ = vala_property_get_property_type (self);
		_tmp204_ = _tmp203_;
		_tmp186_ = !vala_data_type_compatible (_tmp202_, _tmp204_);
	} else {
		_tmp186_ = FALSE;
	}
	if (_tmp186_) {
		ValaExpression* _tmp205_;
		ValaExpression* _tmp206_;
		ValaSourceReference* _tmp207_;
		ValaSourceReference* _tmp208_;
		ValaDataType* _tmp209_;
		ValaDataType* _tmp210_;
		gchar* _tmp211_;
		gchar* _tmp212_;
		ValaExpression* _tmp213_;
		ValaExpression* _tmp214_;
		ValaDataType* _tmp215_;
		ValaDataType* _tmp216_;
		gchar* _tmp217_;
		gchar* _tmp218_;
		gchar* _tmp219_;
		gchar* _tmp220_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp205_ = vala_property_get_initializer (self);
		_tmp206_ = _tmp205_;
		_tmp207_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp206_);
		_tmp208_ = _tmp207_;
		_tmp209_ = vala_property_get_property_type (self);
		_tmp210_ = _tmp209_;
		_tmp211_ = vala_code_node_to_string ((ValaCodeNode*) _tmp210_);
		_tmp212_ = _tmp211_;
		_tmp213_ = vala_property_get_initializer (self);
		_tmp214_ = _tmp213_;
		_tmp215_ = vala_expression_get_value_type (_tmp214_);
		_tmp216_ = _tmp215_;
		_tmp217_ = vala_code_node_to_string ((ValaCodeNode*) _tmp216_);
		_tmp218_ = _tmp217_;
		_tmp219_ = g_strdup_printf ("Expected initializer of type `%s' but got `%s'", _tmp212_, _tmp218_);
		_tmp220_ = _tmp219_;
		vala_report_error (_tmp208_, _tmp220_);
		_g_free0 (_tmp220_);
		_g_free0 (_tmp218_);
		_g_free0 (_tmp212_);
	}
	_tmp221_ = vala_code_context_get_analyzer (context);
	_tmp222_ = _tmp221_;
	_tmp223_ = old_source_file;
	vala_semantic_analyzer_set_current_source_file (_tmp222_, _tmp223_);
	_tmp224_ = vala_code_context_get_analyzer (context);
	_tmp225_ = _tmp224_;
	_tmp226_ = old_symbol;
	vala_semantic_analyzer_set_current_symbol (_tmp225_, _tmp226_);
	_tmp227_ = vala_code_node_get_error ((ValaCodeNode*) self);
	_tmp228_ = _tmp227_;
	result = !_tmp228_;
	_vala_code_node_unref0 (old_symbol);
	_vala_source_file_unref0 (old_source_file);
	return result;
}

static void
vala_property_class_init (ValaPropertyClass * klass,
                          gpointer klass_data)
{
	vala_property_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeNodeClass *) klass)->finalize = vala_property_finalize;
	g_type_class_adjust_private_offset (klass, &ValaProperty_private_offset);
	((ValaCodeNodeClass *) klass)->accept = (void (*) (ValaCodeNode*, ValaCodeVisitor*)) vala_property_real_accept;
	((ValaCodeNodeClass *) klass)->accept_children = (void (*) (ValaCodeNode*, ValaCodeVisitor*)) vala_property_real_accept_children;
	((ValaCodeNodeClass *) klass)->replace_type = (void (*) (ValaCodeNode*, ValaDataType*, ValaDataType*)) vala_property_real_replace_type;
	((ValaCodeNodeClass *) klass)->replace_expression = (void (*) (ValaCodeNode*, ValaExpression*, ValaExpression*)) vala_property_real_replace_expression;
	((ValaCodeNodeClass *) klass)->check = (gboolean (*) (ValaCodeNode*, ValaCodeContext*)) vala_property_real_check;
}

static void
vala_property_vala_lockable_interface_init (ValaLockableIface * iface,
                                            gpointer iface_data)
{
	vala_property_vala_lockable_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_lock_used = vala_property_real_get_lock_used;
	iface->set_lock_used = vala_property_real_set_lock_used;
}

static void
vala_property_instance_init (ValaProperty * self,
                             gpointer klass)
{
	self->priv = vala_property_get_instance_private (self);
	self->priv->_binding = VALA_MEMBER_BINDING_INSTANCE;
}

static void
vala_property_finalize (ValaCodeNode * obj)
{
	ValaProperty * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_PROPERTY, ValaProperty);
	_vala_code_node_unref0 (self->priv->_this_parameter);
	_vala_code_node_unref0 (self->priv->_initializer);
	_vala_code_node_unref0 (self->priv->_data_type);
	_vala_code_node_unref0 (self->priv->_base_interface_property);
	_vala_code_node_unref0 (self->priv->_get_accessor);
	_vala_code_node_unref0 (self->priv->_set_accessor);
	_g_free0 (self->priv->_nick);
	_g_free0 (self->priv->_blurb);
	_g_free0 (self->priv->_notify);
	_vala_code_node_unref0 (self->priv->_field);
	VALA_CODE_NODE_CLASS (vala_property_parent_class)->finalize (obj);
}

/**
 * Represents a property declaration in the source code.
 */
GType
vala_property_get_type (void)
{
	static volatile gsize vala_property_type_id__volatile = 0;
	if (g_once_init_enter (&vala_property_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValaPropertyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_property_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaProperty), 0, (GInstanceInitFunc) vala_property_instance_init, NULL };
		static const GInterfaceInfo vala_lockable_info = { (GInterfaceInitFunc) vala_property_vala_lockable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType vala_property_type_id;
		vala_property_type_id = g_type_register_static (VALA_TYPE_SYMBOL, "ValaProperty", &g_define_type_info, 0);
		g_type_add_interface_static (vala_property_type_id, VALA_TYPE_LOCKABLE, &vala_lockable_info);
		ValaProperty_private_offset = g_type_add_instance_private (vala_property_type_id, sizeof (ValaPropertyPrivate));
		g_once_init_leave (&vala_property_type_id__volatile, vala_property_type_id);
	}
	return vala_property_type_id__volatile;
}

